game_state = "LOAD"

function loadGame(x)

	if x == 0 then
	
		me = love.graphics.newImage("me.png")
		toasty = love.audio.newSource("toast.wav", "static")
		me_transparent = 0
		
	elseif x == 2 then
	
		title_top = love.graphics.newImage("title.png")
		title_bot = love.graphics.newImage("title2.png")
	
	elseif x == 4 then
	
		title_song = love.audio.newSource("title.ogg", "stream")
		title_song:setLooping(true)
	
	elseif x == 6 then
	
		main_song = love.audio.newSource("main.ogg", "stream")
		main_song:setLooping(true)
	
	elseif x == 8 then
	
		level1 = love.graphics.newImage("level1.png")
		level2 = love.graphics.newImage("level2.png")
		level_x = 0
	
	elseif x == 10 then
	
		guy1 = love.graphics.newImage("guy1.png")
		guy2 = love.graphics.newImage("guy2.png")
		guy3 = love.graphics.newImage("guy3.png")
		guy4 = love.graphics.newImage("guy4.png")
		guy_frame = 0
		guy_image = guy1
		guy_scale = 1
		guy_speed = 4
		boss = love.graphics.newImage("boss.png")
	
	elseif x == 12 then
	
		require "pill"
		loadPill()
		click = love.audio.newSource("click.wav", "static")
		
		require "fire"
		loadFire()
		gun1 = love.audio.newSource("gunshot2.wav", "static")
		gun2 = love.audio.newSource("gunshot3.wav", "static")
	
	elseif x == 14 then
	
		walle = love.graphics.newImage("walle.png")
		walle_y = 0
		boss2 = love.graphics.newImage("boss2.png")
	
	elseif x == 16 then
	
		game_over1 = love.graphics.newImage("death1.png")
		game_over2 = love.graphics.newImage("death2.png")
	
	elseif x == 18 then
		
		end1 = love.graphics.newImage("end.png")
		end2 = love.graphics.newImage("end2.png")
		require "boss"
		require "bullet"
		hasDied = false
	
	end
	
end

function unloadIntro()
	me = nil
	toasty = nil
	title_top = nil
	title_bot = nil
end

function isVisible(x)
	return (x + level_x > -80) and (x + level_x < 400)
end

function is3DS()
	return os_model ~= "pc"
end

function getSlider()
	slide = 0
	if is3DS() then
		slide = love.graphics.get3DSlider()
	else
		slide = (240 - math.min(love.mouse.getY(), 240)) / 240
	end
	
	return slide
end

function updateGame(dt)

	timer = timer + 1

	loadStart = 3
	
	if game_state == "LOAD" then
		if os_model == "pc" then
			timer = 20 + loadStart
			for i = 0, timer do
				loadGame(i)
			end
		end
		
		if timer >= loadStart then
			loadGame(timer - loadStart)
		end
		
		if timer > 19 + loadStart then
			game_state = "HOKSY"
			toasty:play()
			timer = 0
		end
	end
	
	if game_state == "HOKSY" then
		if timer < 80 then
			me_transparent = math.min(me_transparent + 24, 255)
		else
			me_transparent = math.max(me_transparent - 24, 0)
		end
		
		if timer > 100 then
			game_state = "TITLE_SCREEN"
			title_song:play()
		end
	end

	if game_state == "TITLE_SCREEN" then
		mouse_x = love.mouse.getX()
		mouse_y = love.mouse.getY()
		timer = 0
		
		if os_model == "pc" then
			mouse_x = mouse_x - 40
			mouse_y = mouse_y - 240
		end
		
		if love.mouse.isDown(1) then
			if mouse_y >= 56 and mouse_y <= 88 then
				game_state = "START"
				title_song:stop()
				unloadIntro()
				main_song:play()
				
				addAllPills()
				addAllFire()
				
				if is3DS() then
					love.graphics.set3D(true)
				end
			end
			
			if mouse_y >= 139 and mouse_y <= 183 then
				love.event.quit()
			end
		end
	end
	
	if game_state == "START" then
		mouse_x = love.mouse.getX()
		mouse_y = love.mouse.getY()
		
		guy_frame = math.floor((timer % 16) / 4)
		if hasDied == false then
			guy_speed = math.max((2000 + level_x) / 3500, 0.1)
		else
			guy_speed = 1
		end
		
		left_btn = "a"
		right_btn = "d"
		if os_model ~= "pc" then
			left_btn = "cpadleft"
			right_btn = "cpadright"
		end
		
		if love.keyboard.isDown(left_btn) then
			guy_scale = -1
			level_x = math.min(0, level_x + guy_speed)
			animateGuy()
		elseif love.keyboard.isDown(right_btn) then
			guy_scale = 1
			level_x = math.max(-2048 + 400, level_x - guy_speed)
			animateGuy()
		end
		
		updatePill(dt)
		updateFire(dt)
		
		if noPills() == false then
			if walle_y ~= -240 then
				walle_y = walle_y - 1
			elseif walle_y == -240 then
				if level_x == -2048 + 400 then
					game_state = "BATTLE"
					loadBoss()
					loadBullet()
					addBullet(250, boss_y + 70, fire1)
					addBullet(90, 40, randomBullet())
					gun1:play()
					gun2:play()
				end
			end
		end
		
	end
	
	if game_state == "BATTLE" then
		updateBoss(dt)
		updateBullet(dt)
	end
	
end

function animateGuy()
	if guy_frame == 0 then
		guy_image = guy1
	elseif guy_frame == 2 then
		guy_image = guy3
	else
		guy_image = guy2
	end
end

function _setDepth(x)
	if is3DS() then
		love.graphics.setDepth(x)
	end
end

function drawGame()
drawTopScreen()
	
	if game_state == "LOAD" then
		love.graphics.rectangle("line", 50, 96, 300, 48)
			loadBar = (math.max(0, math.floor((timer - loadStart) / 2)) + 1) / 10
		love.graphics.rectangle("fill", 56, 102, 288 * loadBar, 36)
		love.graphics.line(49, 96, 49, 96 + 48)
		love.graphics.print("loading, please wait...", 248, 216)
	end
	
	if game_state == "HOKSY" then
		love.graphics.setColor(255, 255, 255, me_transparent)
		love.graphics.draw(me, 0, 0)
		
		love.graphics.setColor(c_white)
		--love.graphics.print(timer, 10, 30)
	end
	
	if game_state == "TITLE_SCREEN" then
		love.graphics.setColor(c_white)
		love.graphics.draw(title_top, 0, 0)
		
		--love.graphics.setColor(c_white)
		--love.graphics.print(mouse_x ..  " " .. mouse_y, 10, 10)
		--love.graphics.print(game_state, 10, 30)
	end
	
	if game_state == "START" then
		_setDepth(16)
		love.graphics.draw(level1, level_x, 0)
		love.graphics.draw(level2, level_x + 1024, 0)
		
		_setDepth(12)
		drawFire()
		
		_setDepth(8)
		drawPill()
		
		if walle_y ~= -240 then
			love.graphics.draw(walle, 1780 + level_x, walle_y)
			love.graphics.setColor(c_black)
			love.graphics.print(getFalsePills() .. "/41", 1780 + level_x + 8, walle_y + 24)
			love.graphics.setColor(c_white)
		end
		
		_setDepth(0)
		xorigin = 0
		if guy_scale == -1 then
			xorigin = 32
		end
		
		yextra = math.max(getSlider() * 240, 40)
		
		love.graphics.draw(guy_image, 90 + xorigin, 200 - yextra + 40, 0, guy_scale, 1, 0, 0)
	end
	
	if game_state == "BATTLE" then
		_setDepth(16)
		love.graphics.draw(level2, -1024 + 400, 0)
		
		_setDepth(8)
		drawBoss()
		drawBullet()
		
		_setDepth(0)
		xorigin = 0
		if guy_scale == -1 then
			xorigin = 32
		end
		
		yextra = math.max(getSlider() * 240, 40)
		
		love.graphics.draw(guy_image, 90 + xorigin, 200 - yextra + 40, 0, guy_scale, 1, 0, 0)
	end
	
	if game_state == "GAME_OVER" then
		_setDepth(16)
		love.graphics.draw(game_over1, 0, 0)
		
		_setDepth(8)
		
		if slide_lock == false then
			yextra = math.max(getSlider() * 240, 40)
			if yextra == 240 then
				--RELOAD GAME
				addAllPills()
				addAllFire()
				level_x = 0
				walle_y = 0
				game_state = "START"
				hasDied = true
			end
		else
			yextra = math.max(getSlider() * 240, 40)
			if yextra == 40 then
				slide_lock = false
			end
			yextra = 40
		end
		love.graphics.draw(guy1, 200 + xorigin - 16, 200 - yextra + 40, 0, guy_scale, 1, 0, 0)
		love.graphics.setColor(255, 255, 255, yextra + 15)
		love.graphics.draw(guy4, 200 + xorigin - 16, 200 - yextra + 40, 0, guy_scale, 1, 0, 0)
		love.graphics.setColor(c_white)
	end
	
	if game_state == "WIN" then
		love.graphics.draw(end1, 0, 0)
	end
	
drawBottomScreen()
	
	if game_state == "TITLE_SCREEN" then
		love.graphics.draw(title_bot, 0, 0)
	end
	
	if game_state == "GAME_OVER" then
		love.graphics.draw(game_over2, 0, 0)
	end
	
	if game_state == "WIN" then
		love.graphics.draw(end2, 0, 0)
	end
	
	--if game_state == "START" then
		--love.graphics.print(math.floor(mouse_x - level_x) ..  " " .. mouse_y, 10, 10)
	--end
	
drawBottomScreenEnd()
end